/* Matrix type header file. */
struct Matrix { int Num_row;
		int Num_col;
		Vec_ptr Row[1];
              };
typedef struct Matrix Mat;
typedef Mat *Mat_ptr;

typedef struct { int d,n,len;  /*double/single, nxn, n*(n+1)/2 */
                 int maxn;     /*Ssmat_getmem never reduces n allocated*/
                 Rtyp *Re,*Im; /*double re and im ptrs*/
                 rtyp *re,*im; /*single re and im ptrs*/
               } Ssmat_struct, *Ssmat_ptr;

void Ssmat_init();
void Ssmat_getmem();
Ssmat_ptr Ssmat_close();
Mat_ptr Ssmat_lud();

Mat_ptr Mat_open();
Mat_ptr Mat_close();
Mat_ptr Mat_sol();
Mat_ptr Mat_grad();
Rtyp Mat_get_re();
Rtyp Mat_get_im();
Rtyp Mat_get_mag();
Rtyp Mat_get_dB();
Rtyp Mat_get_rad();
Rtyp Mat_get_deg();
void Mat_init_re();
void Mat_init_im();
void Mat_init();
void Mat_put_re();
void Mat_put_im();
void Mat_put();
void Mat_get_col();
void Mat_put_col();
void Mat_move();
void Mat_mult();
void Mat_smult();
void Mat_inv();
void Mat_partinv();
void Mat_red();
